<ui:composition xmlns="http://www.w3.org/1999/xhtml"
    xmlns:h="http://java.sun.com/jsf/html"
    xmlns:f="http://java.sun.com/jsf/core"
	xmlns:ui="http://java.sun.com/jsf/facelets"
    xmlns:p="http://primefaces.org/ui"
    xmlns:fn="http://java.sun.com/jsp/jstl/functions">
    <h1>
		<small>Cadastro de Usuarios</small>
	</h1>
    	<p:tabView id="tabUsuarios">
		   <p:tab title="Dados">
		   	<h:form id="form1" enctype="multipart/form-data">
		    	<h:panelGrid columns="4" id="painel" style="width: 34%; margin-top: 20px"
		    			columnClasses="rotulo, campo, rotulo, campo">
			    <p:outputLabel/>
				<h:panelGrid id="fotoUsuario">
					<p:graphicImage cache="false" id="imagemTmp" width="100"
						value="/foto?nome=#{usuarioController.usuarioEdicao.fotoUsuario}"  height="150"
						style="margin: 0 auto;" styleClass="foto">
					</p:graphicImage>
				</h:panelGrid>
		   			
	   			<p:outputLabel value="Imagem"/>
	    			<p:fileUpload 
					fileUploadListener="#{usuarioController.upload}" 
					auto="true" label="Foto" disabled="#{!usuarioController.ativo}"
					update="fotoUsuario">
				</p:fileUpload>
				<p:outputLabel />
				<p:commandButton value="Remover Foto" actionListener="#{usuarioController.removerFoto}"
				process="@this" update="fotoUsuario"/>
		    				    		
		    		<p:outputLabel value="Nome Completo: " for="nomeCompleto"/>
		    		<p:inputText disabled="#{!usuarioController.ativo}" value="#{usuarioController.usuarioEdicao.nomeCompleto}" id="nomeCompleto" size="60" maxlength="80" styleClass="email"/>
		    		
		    		<p:outputLabel value="CPF: " for="cpf"/>
		    		<p:inputMask disabled="#{!usuarioController.ativo}" id="cpf" mask="999.999.999-99" value="#{usuarioController.usuarioEdicao.cpf}"/>
		    		
		    		<p:outputLabel value="Email: " for="email"/>
		    		<p:inputText disabled="#{!usuarioController.ativo}" value="#{usuarioController.usuarioEdicao.email}" id="email" size="40" maxlength="40" />
		    		
		    		<p:outputLabel value="Data de Nascimento: " for="nascimento"/>
		    		<p:calendar disabled="#{!usuarioController.ativo}" id="nascimento" value="#{usuarioController.usuarioEdicao.dataNascimento}" pattern="dd/MM/yyyy" mask="true" />
		    		
		    		<p:outputLabel value="Usuario: " for="usuario"/>
		    		<p:inputText disabled="#{!usuarioController.ativo}" value="#{usuarioController.usuarioEdicao.user}" id="usuario" size="40" maxlength="40" />
		    		
		    		<p:outputLabel value="Senha: " for="senha"/>
		    		<p:password disabled="#{!usuarioController.ativo}" id="senha" match="confirmaSenha" required="true" feedback="true" promptLabel="Entre com a Senha" 
		    		value="#{usuarioController.usuarioEdicao.password}" weakLabel="Fraco" goodLabel="Bom" strongLabel="Excelente"/>
		    		
		    		<p:outputLabel value="Confirma Senha: " for="confirmaSenha"/>
		    		<p:password disabled="#{!usuarioController.ativo}" id="confirmaSenha" required="true" />
		    		
		    		<p:outputLabel value="Perfil" for="perfil"/>
		    		<p:selectOneMenu disabled="#{!usuarioController.ativo}" id="perfil" value="#{usuarioController.usuarioEdicao.perfil}">
						<f:selectItem itemLabel="Selecione" noSelectionOption="true" />
						<f:selectItem itemLabel="Admin" itemValue="admin"/>
						<f:selectItem itemLabel="User" itemValue="user"/>
						<f:selectItem itemLabel="Master" itemValue="master"/>
					</p:selectOneMenu>
					
					<p:outputLabel value="Empresa" for="empresa"/>
		    		<p:selectOneMenu disabled="#{!usuarioController.ativo}" id="empresa" value="#{usuarioController.usuarioEdicao.empresa}" converter="genericConverter">
						<f:selectItem itemLabel="Selecione" noSelectionOption="true" />
						<f:selectItems value="#{usuarioController.listaEmpresas}" var="empresas" itemLabel="#{empresas.nomeFantasia}" itemValue="#{empresas}"/>
					</p:selectOneMenu>
		
		    	</h:panelGrid>
		
		    	<p:toolbar id="tbOpcoes" style="margin-top: 20px">
		    		<p:toolbarGroup>
		    			<p:commandButton value="Salvar" id="botaoSalvar" 
		    							 action="#{usuarioController.salvar}" 
		    							 rendered="#{usuarioController.ativo}"
		    							 update="form1 growl" process="@this painel"/>
		    							 
		    			<p:commandButton value="Novo" id="botaoNovo"
		    							 actionListener="#{usuarioController.ativar}" 
		    							 rendered="#{!usuarioController.ativo}"
		    							 update="tbOpcoes painel" process="@this"/>
		    							 
		    			<p:commandButton value="Cancelar" id="botaoCancelar" 
		    							 rendered="#{usuarioController.ativo}"
		    							 actionListener="#{usuarioController.desativar}"
		    							 update="tbOpcoes painel" process="@this">
		    				<p:resetInput target="painel" />
		    			</p:commandButton>
		    		</p:toolbarGroup>
		    	</p:toolbar>
		   	</h:form>
		   </p:tab>
		   <p:tab title="Consulta">
		    <h:form id="form" enctype="multipart/form-data">	  
		    	<h1>Pesquisar</h1>
    			<br/>
	    		<h:panelGrid  columns="2" id="panel-consulta" style="padding-top: 10px;">
	    		
					<p:outputLabel value="Nome:"/>
					<p:inputText maxlength="80" value="#{usuarioController.pesquisaUsuario.nome}"/>
						
				</h:panelGrid>
			
				<center><p:commandButton value="Buscar" id="buscar"
	   							 actionListener="#{usuarioController.consutaDeUsuario}" 
	   							 update=":tabUsuarios:form:tblUsuario growl" process="@this :tabUsuarios:form:tblUsuario :tabUsuarios:form:panel-consulta"/></center>
		    
		    	<p:dataTable id="tblUsuario" emptyMessage="Nenhum Usuario Encontrado..." paginator="true" value="#{usuarioController.usuarioList}"
		    			paginatorAlwaysVisible="true" paginatorPosition="bottom" style="margin-top: 20px" var="usuarios" rows="4">
		    		
		    		<p:column headerText="Foto" width="50">
						<p:graphicImage rendered="#{usuarios.fotoUsuario != null ? true : false}"
										value="/foto?nome=#{usuarios.fotoUsuario}" 
										styleClass="img-circle" alt="User Image" width="24" height="24">
							<f:param name="image_id" value="#{usuarios.id}"/>
						</p:graphicImage>
						<p:graphicImage rendered="#{usuarios.fotoUsuario == null ? true : false}" 
										value="/resources/dist/img/user.jpg"
										styleClass="img-circle" alt="User Image" width="24" height="24"/>
		    		</p:column>
		    		
		    		<p:column headerText="Nome" >
		    			<h:outputText value="#{usuarios.nomeCompleto}"/>
		    		</p:column>
		    		
		    		<p:column headerText="E-mail" width="200">
		    			<h:outputText value="#{usuarios.email}"/>
		    		</p:column>
		    		
		    		<p:column headerText="Perfil">
		    			<h:outputText value="#{usuarios.perfil}"/>
		    		</p:column>
		    		
		    		<p:column headerText="Data de Criação" width="200">
		    			<h:outputText value="#{usuarios.dataCriacao}">
		    				<f:convertDateTime pattern="dd/MM/yyyy HH:mm:ss" timeZone="GMT-03:00"/>
		    			</h:outputText>
		    		</p:column>
		    		
		    		<p:column headerText="Ações" width="90">
		    			<p:commandButton icon="ui-icon-pencil" title="Editar" onclick="tabView.select(0); return false;"
		    							actionListener="#{usuarioController.editar}" update=":tabUsuarios:form:tblUsuario">
		  					<f:attribute name="usuarioEditado" value="#{usuarios}"/>
		    			</p:commandButton>
		    	
		    			<p:commandButton icon="ui-icon-trash" title="Excluir" actionListener="#{usuarioController.excluir}" 
		    								update=":tabUsuarios:form:tblUsuario growl">
		  					<p:confirm header="Confirmar" message="Desenja excluir Usuario?" icon="ui-icon-alert"/>
		  					<f:attribute name="usuarioExcluido" value="#{usuarios}"/>
		    			</p:commandButton>
		    		</p:column>
		    		<f:facet name="footer">
		                <h:outputText value="Existem " />
		                <h:outputText value="#{fn:length(usuarioController.usuarioList)}" />
		                <h:outputText value=" Usuarios cadastrados. " />
		               </f:facet>
		    	</p:dataTable>
				<p:confirmDialog global="true">
					<p:commandButton value="Sim" type="button"
									styleClass="ui-confirmdialog-yes" icon="ui-icon-check" />
					<p:commandButton value="Nao" type="button" 
									styleClass="ui-confirmdialog-no" icon="ui-icon-close" />
				</p:confirmDialog>
			</h:form>
		</p:tab>
	</p:tabView>
</ui:composition>